Subject: Re: Download throttling with kernel 6.6 (in KVM guests)

From: Jakub Kicinski <[email-masked]>
Date: Mon, 6 Jan 2025 19:19:16 -0800

On Mon, 6 Jan 2025 21:50:02 -0500 Neal Cardwell wrote:
> On Mon, Jan 6, 2025 at 4:20 PM Jakub Kicinski <[email-masked]> wrote:
> > On Mon, 6 Jan 2025 22:15:37 +0200 Teodor Milkov wrote:  
> > > Hello,
> > >
> > > Following up on my previous email, I’ve found the issue occurs
> > > specifically with the |virtio-net| driver in KVM guests. Switching to
> > > the |e1000| driver resolves the slowdown entirely, with no throttling in
> > > subsequent downloads.
> > >
> > > The reproducer and observations remain the same, but this detail might
> > > help narrow down the issue.  
> >
> > Let's CC the virtio maintainers, then.
> >
> > The fact that a 300ms sleep between connections makes the problem
> > go away is a bit odd from the networking perspective.
> >
> > You may need to find a way to automate the test and try to bisect
> > it down :( This may help: https://github.com/arighi/virtme-ng  
> 
> IIUC, from Teodor's earlier message in the thread it sounds like he
> was able to bisect the issue; he mentioned that git bisect traced the
> regression to the commit:
> 
>     dfa2f0483360 ("tcp: get rid of sysctl_tcp_adv_win_scale")

My bad. I think I looked at it last week and couldn't figure out 
why the sleep make any difference.